/*
 * This file is generated by jOOQ.
 */
package de.ship.db.tables;


import de.ship.db.CommonDd;
import de.ship.db.enums.EnumAccesslevel;
import de.ship.db.tables.records.VCoreUserapplrightRecord;

import java.util.Collection;

import org.jooq.Condition;
import org.jooq.Field;
import org.jooq.Name;
import org.jooq.PlainSQL;
import org.jooq.QueryPart;
import org.jooq.SQL;
import org.jooq.Schema;
import org.jooq.Select;
import org.jooq.Stringly;
import org.jooq.Table;
import org.jooq.TableField;
import org.jooq.TableOptions;
import org.jooq.impl.DSL;
import org.jooq.impl.SQLDataType;
import org.jooq.impl.TableImpl;


/**
 * This class is generated by jOOQ.
 */
@SuppressWarnings({ "all", "unchecked", "rawtypes" })
public class VCoreUserapplright extends TableImpl<VCoreUserapplrightRecord> {

    private static final long serialVersionUID = 1L;

    /**
     * The reference instance of <code>common_dd.v_core_userapplright</code>
     */
    public static final VCoreUserapplright V_CORE_USERAPPLRIGHT = new VCoreUserapplright();

    /**
     * The class holding records for this type
     */
    @Override
    public Class<VCoreUserapplrightRecord> getRecordType() {
        return VCoreUserapplrightRecord.class;
    }

    /**
     * The column <code>common_dd.v_core_userapplright.forename</code>.
     */
    public final TableField<VCoreUserapplrightRecord, String> FORENAME = createField(DSL.name("forename"), SQLDataType.CLOB, this, "");

    /**
     * The column <code>common_dd.v_core_userapplright.surname</code>.
     */
    public final TableField<VCoreUserapplrightRecord, String> SURNAME = createField(DSL.name("surname"), SQLDataType.CLOB, this, "");

    /**
     * The column <code>common_dd.v_core_userapplright.username</code>.
     */
    public final TableField<VCoreUserapplrightRecord, String> USERNAME = createField(DSL.name("username"), SQLDataType.CLOB, this, "");

    /**
     * The column <code>common_dd.v_core_userapplright.usnr</code>.
     */
    public final TableField<VCoreUserapplrightRecord, Integer> USNR = createField(DSL.name("usnr"), SQLDataType.INTEGER, this, "");

    /**
     * The column <code>common_dd.v_core_userapplright.name</code>.
     */
    public final TableField<VCoreUserapplrightRecord, String> NAME = createField(DSL.name("name"), SQLDataType.CLOB, this, "");

    /**
     * The column <code>common_dd.v_core_userapplright.pk</code>.
     */
    public final TableField<VCoreUserapplrightRecord, Integer> PK = createField(DSL.name("pk"), SQLDataType.INTEGER, this, "");

    /**
     * The column <code>common_dd.v_core_userapplright.shippie_acl</code>.
     */
    public final TableField<VCoreUserapplrightRecord, EnumAccesslevel> SHIPPIE_ACL = createField(DSL.name("shippie_acl"), SQLDataType.VARCHAR.asEnumDataType(EnumAccesslevel.class), this, "");

    /**
     * The column <code>common_dd.v_core_userapplright.shipdesigner_acl</code>.
     */
    public final TableField<VCoreUserapplrightRecord, EnumAccesslevel> SHIPDESIGNER_ACL = createField(DSL.name("shipdesigner_acl"), SQLDataType.VARCHAR.asEnumDataType(EnumAccesslevel.class), this, "");

    /**
     * The column <code>common_dd.v_core_userapplright.square_acl</code>.
     */
    public final TableField<VCoreUserapplrightRecord, EnumAccesslevel> SQUARE_ACL = createField(DSL.name("square_acl"), SQLDataType.VARCHAR.asEnumDataType(EnumAccesslevel.class), this, "");

    private VCoreUserapplright(Name alias, Table<VCoreUserapplrightRecord> aliased) {
        this(alias, aliased, (Field<?>[]) null, null);
    }

    private VCoreUserapplright(Name alias, Table<VCoreUserapplrightRecord> aliased, Field<?>[] parameters, Condition where) {
        super(alias, null, aliased, parameters, DSL.comment(""), TableOptions.view("""
        create view "v_core_userapplright" as  SELECT t_core_person.forename,
         t_core_person.surname,
         t_core_person.username,
         t_core_person.usnr,
         t_core_privilege.name,
         t_core_privilege.pk,
         t_core_userprivilege.shippie_acl,
         t_core_userprivilege.shipdesigner_acl,
         t_core_userprivilege.square_acl
        FROM ((common_dd.t_core_person
          LEFT JOIN common_dd.t_core_userprivilege ON ((t_core_userprivilege.fk_usnr = t_core_person.usnr)))
          JOIN common_dd.t_core_privilege ON ((t_core_privilege.pk = t_core_userprivilege.fk_privilege)));
        """), where);
    }

    /**
     * Create an aliased <code>common_dd.v_core_userapplright</code> table
     * reference
     */
    public VCoreUserapplright(String alias) {
        this(DSL.name(alias), V_CORE_USERAPPLRIGHT);
    }

    /**
     * Create an aliased <code>common_dd.v_core_userapplright</code> table
     * reference
     */
    public VCoreUserapplright(Name alias) {
        this(alias, V_CORE_USERAPPLRIGHT);
    }

    /**
     * Create a <code>common_dd.v_core_userapplright</code> table reference
     */
    public VCoreUserapplright() {
        this(DSL.name("v_core_userapplright"), null);
    }

    @Override
    public Schema getSchema() {
        return aliased() ? null : CommonDd.COMMON_DD;
    }

    @Override
    public VCoreUserapplright as(String alias) {
        return new VCoreUserapplright(DSL.name(alias), this);
    }

    @Override
    public VCoreUserapplright as(Name alias) {
        return new VCoreUserapplright(alias, this);
    }

    @Override
    public VCoreUserapplright as(Table<?> alias) {
        return new VCoreUserapplright(alias.getQualifiedName(), this);
    }

    /**
     * Rename this table
     */
    @Override
    public VCoreUserapplright rename(String name) {
        return new VCoreUserapplright(DSL.name(name), null);
    }

    /**
     * Rename this table
     */
    @Override
    public VCoreUserapplright rename(Name name) {
        return new VCoreUserapplright(name, null);
    }

    /**
     * Rename this table
     */
    @Override
    public VCoreUserapplright rename(Table<?> name) {
        return new VCoreUserapplright(name.getQualifiedName(), null);
    }

    /**
     * Create an inline derived table from this table
     */
    @Override
    public VCoreUserapplright where(Condition condition) {
        return new VCoreUserapplright(getQualifiedName(), aliased() ? this : null, null, condition);
    }

    /**
     * Create an inline derived table from this table
     */
    @Override
    public VCoreUserapplright where(Collection<? extends Condition> conditions) {
        return where(DSL.and(conditions));
    }

    /**
     * Create an inline derived table from this table
     */
    @Override
    public VCoreUserapplright where(Condition... conditions) {
        return where(DSL.and(conditions));
    }

    /**
     * Create an inline derived table from this table
     */
    @Override
    public VCoreUserapplright where(Field<Boolean> condition) {
        return where(DSL.condition(condition));
    }

    /**
     * Create an inline derived table from this table
     */
    @Override
    @PlainSQL
    public VCoreUserapplright where(SQL condition) {
        return where(DSL.condition(condition));
    }

    /**
     * Create an inline derived table from this table
     */
    @Override
    @PlainSQL
    public VCoreUserapplright where(@Stringly.SQL String condition) {
        return where(DSL.condition(condition));
    }

    /**
     * Create an inline derived table from this table
     */
    @Override
    @PlainSQL
    public VCoreUserapplright where(@Stringly.SQL String condition, Object... binds) {
        return where(DSL.condition(condition, binds));
    }

    /**
     * Create an inline derived table from this table
     */
    @Override
    @PlainSQL
    public VCoreUserapplright where(@Stringly.SQL String condition, QueryPart... parts) {
        return where(DSL.condition(condition, parts));
    }

    /**
     * Create an inline derived table from this table
     */
    @Override
    public VCoreUserapplright whereExists(Select<?> select) {
        return where(DSL.exists(select));
    }

    /**
     * Create an inline derived table from this table
     */
    @Override
    public VCoreUserapplright whereNotExists(Select<?> select) {
        return where(DSL.notExists(select));
    }
}
